/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.285 Revision 1.407
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.285 2007/07/07 17:30:45 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.407 2012/10/11 16:50:53 mgorny Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement 10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions 11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common 12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing. 13# home rather than having multiple ebuilds implementing the same thing.
14# 14#
15# Due to the nature of this eclass, some functions may have maintainers 15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass! 16# different from the overall eclass!
17 17
18inherit multilib portability 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
19 20
20DESCRIPTION="Based on the ${ECLASS} eclass" 21inherit multilib toolchain-funcs user
22
23if has "${EAPI:-0}" 0 1 2; then
21 24
22# @FUNCTION: epause 25# @FUNCTION: epause
23# @USAGE: [seconds] 26# @USAGE: [seconds]
24# @DESCRIPTION: 27# @DESCRIPTION:
25# Sleep for the specified number of seconds (default of 5 seconds). Useful when 28# Sleep for the specified number of seconds (default of 5 seconds). Useful when
26# printing a message the user should probably be reading and often used in 29# printing a message the user should probably be reading and often used in
27# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set, 30# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
28# don't wait at all. 31# don't wait at all. Defined in EAPIs 0 1 and 2.
29epause() { 32epause() {
30 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 33 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
31} 34}
32 35
33# @FUNCTION: ebeep 36# @FUNCTION: ebeep
34# @USAGE: [number of beeps] 37# @USAGE: [number of beeps]
35# @DESCRIPTION: 38# @DESCRIPTION:
36# Issue the specified number of beeps (default of 5 beeps). Useful when 39# Issue the specified number of beeps (default of 5 beeps). Useful when
37# printing a message the user should probably be reading and often used in 40# printing a message the user should probably be reading and often used in
38# conjunction with the epause function. If the EBEEP_IGNORE env var is set, 41# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
39# don't beep at all. 42# don't beep at all. Defined in EAPIs 0 1 and 2.
40ebeep() { 43ebeep() {
41 local n 44 local n
42 if [[ -z ${EBEEP_IGNORE} ]] ; then 45 if [[ -z ${EBEEP_IGNORE} ]] ; then
43 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 46 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
44 echo -ne "\a" 47 echo -ne "\a"
47 sleep 1 50 sleep 1
48 done 51 done
49 fi 52 fi
50} 53}
51 54
52# Default directory where patches are located 55else
56
57ebeep() {
58 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
59}
60
61epause() {
62 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
63}
64
65fi
66
67# @FUNCTION: eqawarn
68# @USAGE: [message]
69# @DESCRIPTION:
70# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72# profile.
73if ! declare -F eqawarn >/dev/null ; then
74 eqawarn() {
75 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 :
77 }
78fi
79
80# @FUNCTION: ecvs_clean
81# @USAGE: [list of dirs]
82# @DESCRIPTION:
83# Remove CVS directories recursiveley. Useful when a source tarball contains
84# internal CVS directories. Defaults to $PWD.
85ecvs_clean() {
86 [[ -z $* ]] && set -- .
87 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
88 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
89}
90
91# @FUNCTION: esvn_clean
92# @USAGE: [list of dirs]
93# @DESCRIPTION:
94# Remove .svn directories recursiveley. Useful when a source tarball contains
95# internal Subversion directories. Defaults to $PWD.
96esvn_clean() {
97 [[ -z $* ]] && set -- .
98 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
99}
100
101# @FUNCTION: estack_push
102# @USAGE: <stack> [items to push]
103# @DESCRIPTION:
104# Push any number of items onto the specified stack. Pick a name that
105# is a valid variable (i.e. stick to alphanumerics), and push as many
106# items as you like onto the stack at once.
107#
108# The following code snippet will echo 5, then 4, then 3, then ...
109# @CODE
110# estack_push mystack 1 2 3 4 5
111# while estack_pop mystack i ; do
112# echo "${i}"
113# done
114# @CODE
115estack_push() {
116 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117 local stack_name="__ESTACK_$1__" ; shift
118 eval ${stack_name}+=\( \"\$@\" \)
119}
120
121# @FUNCTION: estack_pop
122# @USAGE: <stack> [variable]
123# @DESCRIPTION:
124# Pop a single item off the specified stack. If a variable is specified,
125# the popped item is stored there. If no more items are available, return
126# 1, else return 0. See estack_push for more info.
127estack_pop() {
128 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
129
130 # We use the fugly __estack_xxx var names to avoid collision with
131 # passing back the return value. If we used "local i" and the
132 # caller ran `estack_pop ... i`, we'd end up setting the local
133 # copy of "i" rather than the caller's copy. The __estack_xxx
134 # garbage is preferable to using $1/$2 everywhere as that is a
135 # bit harder to read.
136 local __estack_name="__ESTACK_$1__" ; shift
137 local __estack_retvar=$1 ; shift
138 eval local __estack_i=\${#${__estack_name}\[@\]}
139 # Don't warn -- let the caller interpret this as a failure
140 # or as normal behavior (akin to `shift`)
141 [[ $(( --__estack_i )) -eq -1 ]] && return 1
142
143 if [[ -n ${__estack_retvar} ]] ; then
144 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
145 fi
146 eval unset ${__estack_name}\[${__estack_i}\]
147}
148
149# @FUNCTION: eshopts_push
150# @USAGE: [options to `set` or `shopt`]
151# @DESCRIPTION:
152# Often times code will want to enable a shell option to change code behavior.
153# Since changing shell options can easily break other pieces of code (which
154# assume the default state), eshopts_push is used to (1) push the current shell
155# options onto a stack and (2) pass the specified arguments to set.
156#
157# If the first argument is '-s' or '-u', we assume you want to call `shopt`
158# rather than `set` as there are some options only available via that.
159#
160# A common example is to disable shell globbing so that special meaning/care
161# may be used with variables/arguments to custom functions. That would be:
162# @CODE
163# eshopts_push -s noglob
164# for x in ${foo} ; do
165# if ...some check... ; then
166# eshopts_pop
167# return 0
168# fi
169# done
170# eshopts_pop
171# @CODE
172eshopts_push() {
173 if [[ $1 == -[su] ]] ; then
174 estack_push eshopts "$(shopt -p)"
175 [[ $# -eq 0 ]] && return 0
176 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
177 else
178 estack_push eshopts $-
179 [[ $# -eq 0 ]] && return 0
180 set "$@" || die "${FUNCNAME}: bad options to set: $*"
181 fi
182}
183
184# @FUNCTION: eshopts_pop
185# @USAGE:
186# @DESCRIPTION:
187# Restore the shell options to the state saved with the corresponding
188# eshopts_push call. See that function for more details.
189eshopts_pop() {
190 local s
191 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
192 if [[ ${s} == "shopt -"* ]] ; then
193 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
194 else
195 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
196 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
197 fi
198}
199
200# @FUNCTION: eumask_push
201# @USAGE: <new umask>
202# @DESCRIPTION:
203# Set the umask to the new value specified while saving the previous
204# value onto a stack. Useful for temporarily changing the umask.
205eumask_push() {
206 estack_push eumask "$(umask)"
207 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
208}
209
210# @FUNCTION: eumask_pop
211# @USAGE:
212# @DESCRIPTION:
213# Restore the previous umask state.
214eumask_pop() {
215 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
216 local s
217 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
218 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
219}
220
221# @VARIABLE: EPATCH_SOURCE
222# @DESCRIPTION:
223# Default directory to search for patches.
53EPATCH_SOURCE="${WORKDIR}/patch" 224EPATCH_SOURCE="${WORKDIR}/patch"
54# Default extension for patches 225# @VARIABLE: EPATCH_SUFFIX
226# @DESCRIPTION:
227# Default extension for patches (do not prefix the period yourself).
55EPATCH_SUFFIX="patch.bz2" 228EPATCH_SUFFIX="patch.bz2"
56# Default options for patch 229# @VARIABLE: EPATCH_OPTS
230# @DESCRIPTION:
231# Options to pass to patch. Meant for ebuild/package-specific tweaking
232# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
233# for single patch tweaking, you can also pass flags directly to epatch.
234EPATCH_OPTS=""
235# @VARIABLE: EPATCH_COMMON_OPTS
236# @DESCRIPTION:
237# Common options to pass to `patch`. You probably should never need to
238# change these. If you do, please discuss it with base-system first to
239# be sure.
240# @CODE
57# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 241# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
58# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 242# --no-backup-if-mismatch - do not leave .orig files behind
59# Set -E to automatically remove empty files. 243# -E - automatically remove empty files
244# @CODE
60EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 245EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
246# @VARIABLE: EPATCH_EXCLUDE
247# @DESCRIPTION:
61# List of patches not to apply. Not this is only file names, 248# List of patches not to apply. Note this is only file names,
62# and not the full path .. 249# and not the full path. Globs accepted.
63EPATCH_EXCLUDE="" 250EPATCH_EXCLUDE=""
251# @VARIABLE: EPATCH_SINGLE_MSG
252# @DESCRIPTION:
64# Change the printed message for a single patch. 253# Change the printed message for a single patch.
65EPATCH_SINGLE_MSG="" 254EPATCH_SINGLE_MSG=""
255# @VARIABLE: EPATCH_MULTI_MSG
256# @DESCRIPTION:
66# Change the printed message for multiple patches. 257# Change the printed message for multiple patches.
67EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 258EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
68# Force applying bulk patches even if not following the style: 259# @VARIABLE: EPATCH_FORCE
69# 260# @DESCRIPTION:
70# ??_${ARCH}_foo.${EPATCH_SUFFIX} 261# Only require patches to match EPATCH_SUFFIX rather than the extended
71# 262# arch naming style.
72EPATCH_FORCE="no" 263EPATCH_FORCE="no"
73 264
74# This function is for bulk patching, or in theory for just one 265# @FUNCTION: epatch
75# or two patches. 266# @USAGE: [options] [patches] [dirs of patches]
267# @DESCRIPTION:
268# epatch is designed to greatly simplify the application of patches. It can
269# process patch files directly, or directories of patches. The patches may be
270# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
271# the -p option as epatch will automatically attempt -p0 to -p5 until things
272# apply successfully.
76# 273#
77# It should work with .bz2, .gz, .zip and plain text patches. 274# If you do not specify any patches/dirs, then epatch will default to the
78# Currently all patches should be the same format. 275# directory specified by EPATCH_SOURCE.
79# 276#
80# You do not have to specify '-p' option to patch, as it will 277# Any options specified that start with a dash will be passed down to patch
81# try with -p0 to -p5 until it succeed, or fail at -p5. 278# for this specific invocation. As soon as an arg w/out a dash is found, then
279# arg processing stops.
82# 280#
83# Above EPATCH_* variables can be used to control various defaults, 281# When processing directories, epatch will apply all patches that match:
84# bug they should be left as is to ensure an ebuild can rely on 282# @CODE
85# them for. 283# if ${EPATCH_FORCE} != "yes"
86#
87# Patches are applied in current directory.
88#
89# Bulk Patches should preferibly have the form of:
90#
91# ??_${ARCH}_foo.${EPATCH_SUFFIX} 284# ??_${ARCH}_foo.${EPATCH_SUFFIX}
285# else
286# *.${EPATCH_SUFFIX}
287# @CODE
288# The leading ?? are typically numbers used to force consistent patch ordering.
289# The arch field is used to apply patches only for the host architecture with
290# the special value of "all" means apply for everyone. Note that using values
291# other than "all" is highly discouraged -- you should apply patches all the
292# time and let architecture details be detected at configure/compile time.
92# 293#
93# For example: 294# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
295# for patches to apply.
94# 296#
95# 01_all_misc-fix.patch.bz2 297# Refer to the other EPATCH_xxx variables for more customization of behavior.
96# 02_sparc_another-fix.patch.bz2
97#
98# This ensures that there are a set order, and you can have ARCH
99# specific patches.
100#
101# If you however give an argument to epatch(), it will treat it as a
102# single patch that need to be applied if its a file. If on the other
103# hand its a directory, it will set EPATCH_SOURCE to this.
104#
105# <azarah@gentoo.org> (10 Nov 2002)
106#
107epatch() { 298epatch() {
108 _epatch_draw_line() { 299 _epatch_draw_line() {
300 # create a line of same length as input string
109 [[ -z $1 ]] && set "$(printf "%65s" '')" 301 [[ -z $1 ]] && set "$(printf "%65s" '')"
110 echo "${1//?/=}" 302 echo "${1//?/=}"
111 } 303 }
112 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
113 local PIPE_CMD=""
114 local STDERR_TARGET="${T}/$$.out"
115 local PATCH_TARGET="${T}/$$.patch"
116 local PATCH_SUFFIX=""
117 local SINGLE_PATCH="no"
118 local x=""
119 304
120 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 305 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
121 306
122 if [ "$#" -gt 1 ] 307 # First process options. We localize the EPATCH_OPTS setting
123 then 308 # from above so that we can pass it on in the loop below with
309 # any additional values the user has specified.
310 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
311 while [[ $# -gt 0 ]] ; do
312 case $1 in
313 -*) EPATCH_OPTS+=( "$1" ) ;;
314 *) break ;;
315 esac
316 shift
317 done
318
319 # Let the rest of the code process one user arg at a time --
320 # each arg may expand into multiple patches, and each arg may
321 # need to start off with the default global EPATCH_xxx values
322 if [[ $# -gt 1 ]] ; then
124 local m="" 323 local m
125 for m in "$@" ; do 324 for m in "$@" ; do
126 epatch "${m}" 325 epatch "${m}"
127 done 326 done
128 return 0 327 return 0
129 fi 328 fi
130 329
131 if [ -n "$1" -a -f "$1" ] 330 local SINGLE_PATCH="no"
132 then 331 # no args means process ${EPATCH_SOURCE}
332 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
333
334 if [[ -f $1 ]] ; then
133 SINGLE_PATCH="yes" 335 SINGLE_PATCH="yes"
134 336 set -- "$1"
135 local EPATCH_SOURCE="$1" 337 # Use the suffix from the single patch (localize it); the code
338 # below will find the suffix for us
136 local EPATCH_SUFFIX="${1##*\.}" 339 local EPATCH_SUFFIX=$1
137 340
138 elif [ -n "$1" -a -d "$1" ] 341 elif [[ -d $1 ]] ; then
139 then 342 # Some people like to make dirs of patches w/out suffixes (vim)
140 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 343 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
141 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 344
345 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
346 # Re-use EPATCH_SOURCE as a search dir
347 epatch "${EPATCH_SOURCE}/$1"
348 return $?
349
350 else
351 # sanity check ... if it isn't a dir or file, wtf man ?
352 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
353 echo
354 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
355 eerror
356 eerror " ${EPATCH_SOURCE}"
357 eerror " ( ${EPATCH_SOURCE##*/} )"
358 echo
359 die "Cannot find \$EPATCH_SOURCE!"
360 fi
361
362 # Now that we know we're actually going to apply something, merge
363 # all of the patch options back in to a single variable for below.
364 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
365
366 local PIPE_CMD
367 case ${EPATCH_SUFFIX##*\.} in
368 xz) PIPE_CMD="xz -dc" ;;
369 lzma) PIPE_CMD="lzma -dc" ;;
370 bz2) PIPE_CMD="bzip2 -dc" ;;
371 gz|Z|z) PIPE_CMD="gzip -dc" ;;
372 ZIP|zip) PIPE_CMD="unzip -p" ;;
373 *) ;;
374 esac
375
376 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
377
378 local x
379 for x in "$@" ; do
380 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
381 # didn't match anything, ignore continue on
382 [[ ! -f ${x} ]] && continue
383
384 local patchname=${x##*/}
385
386 # Apply single patches, or forced sets of patches, or
387 # patches with ARCH dependant names.
388 # ???_arch_foo.patch
389 # Else, skip this input altogether
390 local a=${patchname#*_} # strip the ???_
391 a=${a%%_*} # strip the _foo.patch
392 if ! [[ ${SINGLE_PATCH} == "yes" || \
393 ${EPATCH_FORCE} == "yes" || \
394 ${a} == all || \
395 ${a} == ${ARCH} ]]
142 then 396 then
143 local EPATCH_SOURCE="$1/*" 397 continue
398 fi
399
400 # Let people filter things dynamically
401 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
402 # let people use globs in the exclude
403 eshopts_push -o noglob
404
405 local ex
406 for ex in ${EPATCH_EXCLUDE} ; do
407 if [[ ${patchname} == ${ex} ]] ; then
408 eshopts_pop
409 continue 2
410 fi
411 done
412
413 eshopts_pop
414 fi
415
416 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
417 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
418 einfo "${EPATCH_SINGLE_MSG}"
419 else
420 einfo "Applying ${patchname} ..."
421 fi
144 else 422 else
145 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 423 einfo " ${patchname} ..."
146 fi 424 fi
147 else 425
148 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 426 # most of the time, there will only be one run per unique name,
149 then 427 # but if there are more, make sure we get unique log filenames
150 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 428 local STDERR_TARGET="${T}/${patchname}.out"
151 then 429 if [[ -e ${STDERR_TARGET} ]] ; then
152 EPATCH_SOURCE="$1" 430 STDERR_TARGET="${T}/${patchname}-$$.out"
431 fi
432
433 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
434
435 # Decompress the patch if need be
436 local count=0
437 local PATCH_TARGET
438 if [[ -n ${PIPE_CMD} ]] ; then
439 PATCH_TARGET="${T}/$$.patch"
440 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
441
442 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
443 echo
444 eerror "Could not extract patch!"
445 #die "Could not extract patch!"
446 count=5
447 break
153 fi 448 fi
449 else
450 PATCH_TARGET=${x}
451 fi
154 452
453 # Check for absolute paths in patches. If sandbox is disabled,
454 # people could (accidently) patch files in the root filesystem.
455 # Or trigger other unpleasantries #237667. So disallow -p0 on
456 # such patches.
457 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
458 if [[ -n ${abs_paths} ]] ; then
459 count=1
460 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
461 fi
462 # Similar reason, but with relative paths.
463 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
464 if [[ -n ${rel_paths} ]] ; then
465 eqawarn "QA Notice: Your patch uses relative paths '../'."
466 eqawarn " In the future this will cause a failure."
467 eqawarn "${rel_paths}"
468 fi
469
470 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
471 local patch_cmd
472 while [[ ${count} -lt 5 ]] ; do
473 patch_cmd="${BASH_ALIASES[patch]:-patch} -p${count} ${EPATCH_OPTS}"
474
475 # Generate some useful debug info ...
476 (
477 _epatch_draw_line "***** ${patchname} *****"
155 echo 478 echo
156 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 479 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
480 echo
481 _epatch_draw_line "***** ${patchname} *****"
482 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
483 ret=$?
484 echo
485 echo "patch program exited with status ${ret}"
486 exit ${ret}
487 ) >> "${STDERR_TARGET}"
488
489 if [ $? -eq 0 ] ; then
490 (
491 _epatch_draw_line "***** ${patchname} *****"
492 echo
493 echo "ACTUALLY APPLYING ${patchname} ..."
494 echo
495 _epatch_draw_line "***** ${patchname} *****"
496 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
497 ret=$?
498 echo
499 echo "patch program exited with status ${ret}"
500 exit ${ret}
501 ) >> "${STDERR_TARGET}"
502
503 if [ $? -ne 0 ] ; then
504 echo
505 eerror "A dry-run of patch command succeeded, but actually"
506 eerror "applying the patch failed!"
507 #die "Real world sux compared to the dreamworld!"
508 count=5
509 fi
510 break
511 fi
512
513 : $(( count++ ))
514 done
515
516 # if we had to decompress the patch, delete the temp one
517 if [[ -n ${PIPE_CMD} ]] ; then
518 rm -f "${PATCH_TARGET}"
519 fi
520
521 if [[ ${count} -ge 5 ]] ; then
522 echo
523 eerror "Failed Patch: ${patchname} !"
524 eerror " ( ${PATCH_TARGET} )"
157 eerror 525 eerror
158 eerror " ${EPATCH_SOURCE}" 526 eerror "Include in your bugreport the contents of:"
159 eerror " ( ${EPATCH_SOURCE##*/} )" 527 eerror
528 eerror " ${STDERR_TARGET}"
160 echo 529 echo
161 die "Cannot find \$EPATCH_SOURCE!"
162 fi
163
164 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
165 fi
166
167 case ${EPATCH_SUFFIX##*\.} in
168 bz2)
169 PIPE_CMD="bzip2 -dc"
170 PATCH_SUFFIX="bz2"
171 ;;
172 gz|Z|z)
173 PIPE_CMD="gzip -dc"
174 PATCH_SUFFIX="gz"
175 ;;
176 ZIP|zip)
177 PIPE_CMD="unzip -p"
178 PATCH_SUFFIX="zip"
179 ;;
180 *)
181 PIPE_CMD="cat"
182 PATCH_SUFFIX="patch"
183 ;;
184 esac
185
186 if [ "${SINGLE_PATCH}" = "no" ]
187 then
188 einfo "${EPATCH_MULTI_MSG}"
189 fi
190 for x in ${EPATCH_SOURCE}
191 do
192 # New ARCH dependant patch naming scheme ...
193 #
194 # ???_arch_foo.patch
195 #
196 if [ -f ${x} ] && \
197 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
198 [ "${EPATCH_FORCE}" = "yes" ])
199 then
200 local count=0
201 local popts="${EPATCH_OPTS}"
202 local patchname=${x##*/}
203
204 if [ -n "${EPATCH_EXCLUDE}" ]
205 then
206 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
207 then
208 continue
209 fi
210 fi
211
212 if [ "${SINGLE_PATCH}" = "yes" ]
213 then
214 if [ -n "${EPATCH_SINGLE_MSG}" ]
215 then
216 einfo "${EPATCH_SINGLE_MSG}"
217 else
218 einfo "Applying ${patchname} ..."
219 fi
220 else
221 einfo " ${patchname} ..."
222 fi
223
224 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
225 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
226
227 # Allow for prefix to differ ... im lazy, so shoot me :/
228 while [ "${count}" -lt 5 ]
229 do
230 # Generate some useful debug info ...
231 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
232 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
233
234 if [ "${PATCH_SUFFIX}" != "patch" ]
235 then
236 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
237 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
238 else
239 PATCH_TARGET="${x}"
240 fi
241
242 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
243 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
244
245 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
246 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
247
248 if [ "${PATCH_SUFFIX}" != "patch" ]
249 then
250 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
251 then
252 echo
253 eerror "Could not extract patch!"
254 #die "Could not extract patch!"
255 count=5
256 break
257 fi
258 fi
259
260 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
261 then
262 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
263 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
264 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
265 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
266 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
267
268 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
269 _epatch_assert
270
271 if [ "$?" -ne 0 ]
272 then
273 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
274 echo
275 eerror "A dry-run of patch command succeeded, but actually"
276 eerror "applying the patch failed!"
277 #die "Real world sux compared to the dreamworld!"
278 count=5
279 fi
280
281 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
282
283 break
284 fi
285
286 count=$((count + 1))
287 done
288
289 if [ "${PATCH_SUFFIX}" != "patch" ]
290 then
291 rm -f ${PATCH_TARGET}
292 fi
293
294 if [ "${count}" -eq 5 ]
295 then
296 echo
297 eerror "Failed Patch: ${patchname} !"
298 eerror " ( ${PATCH_TARGET} )"
299 eerror
300 eerror "Include in your bugreport the contents of:"
301 eerror
302 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
303 echo
304 die "Failed Patch: ${patchname}!" 530 die "Failed Patch: ${patchname}!"
305 fi 531 fi
306 532
307 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 533 # if everything worked, delete the full debug patch log
534 rm -f "${STDERR_TARGET}"
308 535
536 # then log away the exact stuff for people to review later
537 cat <<-EOF >> "${T}/epatch.log"
538 PATCH: ${x}
539 CMD: ${patch_cmd}
540 PWD: ${PWD}
541
542 EOF
309 eend 0 543 eend 0
310 fi
311 done 544 done
312 if [ "${SINGLE_PATCH}" = "no" ] 545
313 then 546 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
314 einfo "Done with patching" 547 : # everything worked
548}
549
550# @FUNCTION: epatch_user
551# @USAGE:
552# @DESCRIPTION:
553# Applies user-provided patches to the source tree. The patches are
554# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>[:SLOT]/, where the first
555# of these three directories to exist will be the one to use, ignoring
556# any more general directories which might exist as well. They must end
557# in ".patch" to be applied.
558#
559# User patches are intended for quick testing of patches without ebuild
560# modifications, as well as for permanent customizations a user might
561# desire. Obviously, there can be no official support for arbitrarily
562# patched ebuilds. So whenever a build log in a bug report mentions that
563# user patches were applied, the user should be asked to reproduce the
564# problem without these.
565#
566# Not all ebuilds do call this function, so placing patches in the
567# stated directory might or might not work, depending on the package and
568# the eclasses it inherits and uses. It is safe to call the function
569# repeatedly, so it is always possible to add a call at the ebuild
570# level. The first call is the time when the patches will be
571# applied.
572#
573# Ideally, this function should be called after gentoo-specific patches
574# have been applied, so that their code can be modified as well, but
575# before calls to e.g. eautoreconf, as the user patches might affect
576# autotool input files as well.
577epatch_user() {
578 [[ $# -ne 0 ]] && die "epatch_user takes no options"
579
580 # Allow multiple calls to this function; ignore all but the first
581 local applied="${T}/epatch_user.log"
582 [[ -e ${applied} ]] && return 2
583
584 # don't clobber any EPATCH vars that the parent might want
585 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
586 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
587 EPATCH_SOURCE=${base}/${CTARGET}/${check}
588 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
589 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
590 if [[ -d ${EPATCH_SOURCE} ]] ; then
591 EPATCH_SOURCE=${EPATCH_SOURCE} \
592 EPATCH_SUFFIX="patch" \
593 EPATCH_FORCE="yes" \
594 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
595 epatch
596 echo "${EPATCH_SOURCE}" > "${applied}"
597 return 0
315 fi 598 fi
599 done
600 echo "none" > "${applied}"
601 return 1
316} 602}
317 603
318# @FUNCTION: emktemp 604# @FUNCTION: emktemp
319# @USAGE: [temp dir] 605# @USAGE: [temp dir]
320# @DESCRIPTION: 606# @DESCRIPTION:
348 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX 634 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
349 fi 635 fi
350 fi 636 fi
351} 637}
352 638
353# @FUNCTION: egetent
354# @USAGE: <database> <key>
355# @MAINTAINER:
356# base-system@gentoo.org (Linux)
357# Joe Jezak <josejx@gmail.com> (OS X)
358# usata@gentoo.org (OS X)
359# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
360# @DESCRIPTION:
361# Small wrapper for getent (Linux), nidump (Mac OS X),
362# and pw (FreeBSD) used in enewuser()/enewgroup()
363egetent() {
364 case ${CHOST} in
365 *-darwin*)
366 case "$2" in
367 *[!0-9]*) # Non numeric
368 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
369 ;;
370 *) # Numeric
371 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
372 ;;
373 esac
374 ;;
375 *-freebsd*|*-dragonfly*)
376 local opts action="user"
377 [[ $1 == "passwd" ]] || action="group"
378
379 # lookup by uid/gid
380 if [[ $2 == [[:digit:]]* ]] ; then
381 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
382 fi
383
384 pw show ${action} ${opts} "$2" -q
385 ;;
386 *-netbsd*|*-openbsd*)
387 grep "$2:\*:" /etc/$1
388 ;;
389 *)
390 type -p nscd >& /dev/null && nscd -i "$1"
391 getent "$1" "$2"
392 ;;
393 esac
394}
395
396# @FUNCTION: enewuser
397# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
398# @DESCRIPTION:
399# Same as enewgroup, you are not required to understand how to properly add
400# a user to the system. The only required parameter is the username.
401# Default uid is (pass -1 for this) next available, default shell is
402# /bin/false, default homedir is /dev/null, there are no default groups,
403# and default params sets the comment as 'added by portage for ${PN}'.
404enewuser() {
405 case ${EBUILD_PHASE} in
406 unpack|compile|test|install)
407 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
408 eerror "Package fails at QA and at life. Please file a bug."
409 die "Bad package! enewuser is only for use in pkg_* functions!"
410 esac
411
412 # get the username
413 local euser=$1; shift
414 if [[ -z ${euser} ]] ; then
415 eerror "No username specified !"
416 die "Cannot call enewuser without a username"
417 fi
418
419 # lets see if the username already exists
420 if [[ -n $(egetent passwd "${euser}") ]] ; then
421 return 0
422 fi
423 einfo "Adding user '${euser}' to your system ..."
424
425 # options to pass to useradd
426 local opts=
427
428 # handle uid
429 local euid=$1; shift
430 if [[ -n ${euid} && ${euid} != -1 ]] ; then
431 if [[ ${euid} -gt 0 ]] ; then
432 if [[ -n $(egetent passwd ${euid}) ]] ; then
433 euid="next"
434 fi
435 else
436 eerror "Userid given but is not greater than 0 !"
437 die "${euid} is not a valid UID"
438 fi
439 else
440 euid="next"
441 fi
442 if [[ ${euid} == "next" ]] ; then
443 for ((euid = 101; euid <= 999; euid++)); do
444 [[ -z $(egetent passwd ${euid}) ]] && break
445 done
446 fi
447 opts="${opts} -u ${euid}"
448 einfo " - Userid: ${euid}"
449
450 # handle shell
451 local eshell=$1; shift
452 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
453 if [[ ! -e ${ROOT}${eshell} ]] ; then
454 eerror "A shell was specified but it does not exist !"
455 die "${eshell} does not exist in ${ROOT}"
456 fi
457 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
458 eerror "Do not specify ${eshell} yourself, use -1"
459 die "Pass '-1' as the shell parameter"
460 fi
461 else
462 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
463 [[ -x ${ROOT}${shell} ]] && break
464 done
465
466 if [[ ${shell} == "/dev/null" ]] ; then
467 eerror "Unable to identify the shell to use, proceeding with userland default."
468 case ${USERLAND} in
469 GNU) shell="/bin/false" ;;
470 BSD) shell="/sbin/nologin" ;;
471 Darwin) shell="/usr/sbin/nologin" ;;
472 *) die "Unable to identify the default shell for userland ${USERLAND}"
473 esac
474 fi
475
476 eshell=${shell}
477 fi
478 einfo " - Shell: ${eshell}"
479 opts="${opts} -s ${eshell}"
480
481 # handle homedir
482 local ehome=$1; shift
483 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
484 ehome="/dev/null"
485 fi
486 einfo " - Home: ${ehome}"
487 opts="${opts} -d ${ehome}"
488
489 # handle groups
490 local egroups=$1; shift
491 if [[ ! -z ${egroups} ]] ; then
492 local oldifs=${IFS}
493 local defgroup="" exgroups=""
494
495 export IFS=","
496 for g in ${egroups} ; do
497 export IFS=${oldifs}
498 if [[ -z $(egetent group "${g}") ]] ; then
499 eerror "You must add group ${g} to the system first"
500 die "${g} is not a valid GID"
501 fi
502 if [[ -z ${defgroup} ]] ; then
503 defgroup=${g}
504 else
505 exgroups="${exgroups},${g}"
506 fi
507 export IFS=","
508 done
509 export IFS=${oldifs}
510
511 opts="${opts} -g ${defgroup}"
512 if [[ ! -z ${exgroups} ]] ; then
513 opts="${opts} -G ${exgroups:1}"
514 fi
515 else
516 egroups="(none)"
517 fi
518 einfo " - Groups: ${egroups}"
519
520 # handle extra and add the user
521 local oldsandbox=${SANDBOX_ON}
522 export SANDBOX_ON="0"
523 case ${CHOST} in
524 *-darwin*)
525 ### Make the user
526 if [[ -z $@ ]] ; then
527 dscl . create /users/${euser} uid ${euid}
528 dscl . create /users/${euser} shell ${eshell}
529 dscl . create /users/${euser} home ${ehome}
530 dscl . create /users/${euser} realname "added by portage for ${PN}"
531 ### Add the user to the groups specified
532 local oldifs=${IFS}
533 export IFS=","
534 for g in ${egroups} ; do
535 dscl . merge /groups/${g} users ${euser}
536 done
537 export IFS=${oldifs}
538 else
539 einfo "Extra options are not supported on Darwin yet"
540 einfo "Please report the ebuild along with the info below"
541 einfo "eextra: $@"
542 die "Required function missing"
543 fi
544 ;;
545 *-freebsd*|*-dragonfly*)
546 if [[ -z $@ ]] ; then
547 pw useradd ${euser} ${opts} \
548 -c "added by portage for ${PN}" \
549 die "enewuser failed"
550 else
551 einfo " - Extra: $@"
552 pw useradd ${euser} ${opts} \
553 "$@" || die "enewuser failed"
554 fi
555 ;;
556
557 *-netbsd*)
558 if [[ -z $@ ]] ; then
559 useradd ${opts} ${euser} || die "enewuser failed"
560 else
561 einfo " - Extra: $@"
562 useradd ${opts} ${euser} "$@" || die "enewuser failed"
563 fi
564 ;;
565
566 *-openbsd*)
567 if [[ -z $@ ]] ; then
568 useradd -u ${euid} -s ${eshell} \
569 -d ${ehome} -c "Added by portage for ${PN}" \
570 -g ${egroups} ${euser} || die "enewuser failed"
571 else
572 einfo " - Extra: $@"
573 useradd -u ${euid} -s ${eshell} \
574 -d ${ehome} -c "Added by portage for ${PN}" \
575 -g ${egroups} ${euser} "$@" || die "enewuser failed"
576 fi
577 ;;
578
579 *)
580 if [[ -z $@ ]] ; then
581 useradd ${opts} ${euser} \
582 -c "added by portage for ${PN}" \
583 || die "enewuser failed"
584 else
585 einfo " - Extra: $@"
586 useradd ${opts} ${euser} "$@" \
587 || die "enewuser failed"
588 fi
589 ;;
590 esac
591
592 if [[ ! -e ${ROOT}/${ehome} ]] ; then
593 einfo " - Creating ${ehome} in ${ROOT}"
594 mkdir -p "${ROOT}/${ehome}"
595 chown ${euser} "${ROOT}/${ehome}"
596 chmod 755 "${ROOT}/${ehome}"
597 fi
598
599 export SANDBOX_ON=${oldsandbox}
600}
601
602# @FUNCTION: enewgroup
603# @USAGE: <group> [gid]
604# @DESCRIPTION:
605# This function does not require you to understand how to properly add a
606# group to the system. Just give it a group name to add and enewgroup will
607# do the rest. You may specify the gid for the group or allow the group to
608# allocate the next available one.
609enewgroup() {
610 case ${EBUILD_PHASE} in
611 unpack|compile|test|install)
612 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
613 eerror "Package fails at QA and at life. Please file a bug."
614 die "Bad package! enewgroup is only for use in pkg_* functions!"
615 esac
616
617 # get the group
618 local egroup="$1"; shift
619 if [ -z "${egroup}" ]
620 then
621 eerror "No group specified !"
622 die "Cannot call enewgroup without a group"
623 fi
624
625 # see if group already exists
626 if [[ -n $(egetent group "${egroup}") ]]; then
627 return 0
628 fi
629 einfo "Adding group '${egroup}' to your system ..."
630
631 # options to pass to useradd
632 local opts=
633
634 # handle gid
635 local egid="$1"; shift
636 if [ ! -z "${egid}" ]
637 then
638 if [ "${egid}" -gt 0 ]
639 then
640 if [ -z "`egetent group ${egid}`" ]
641 then
642 if [[ "${CHOST}" == *-darwin* ]]; then
643 opts="${opts} ${egid}"
644 else
645 opts="${opts} -g ${egid}"
646 fi
647 else
648 egid="next available; requested gid taken"
649 fi
650 else
651 eerror "Groupid given but is not greater than 0 !"
652 die "${egid} is not a valid GID"
653 fi
654 else
655 egid="next available"
656 fi
657 einfo " - Groupid: ${egid}"
658
659 # handle extra
660 local eextra="$@"
661 opts="${opts} ${eextra}"
662
663 # add the group
664 local oldsandbox="${SANDBOX_ON}"
665 export SANDBOX_ON="0"
666 case ${CHOST} in
667 *-darwin*)
668 if [ ! -z "${eextra}" ];
669 then
670 einfo "Extra options are not supported on Darwin/OS X yet"
671 einfo "Please report the ebuild along with the info below"
672 einfo "eextra: ${eextra}"
673 die "Required function missing"
674 fi
675
676 # If we need the next available
677 case ${egid} in
678 *[!0-9]*) # Non numeric
679 for ((egid = 101; egid <= 999; egid++)); do
680 [[ -z $(egetent group ${egid}) ]] && break
681 done
682 esac
683 dscl . create /groups/${egroup} gid ${egid}
684 dscl . create /groups/${egroup} passwd '*'
685 ;;
686
687 *-freebsd*|*-dragonfly*)
688 case ${egid} in
689 *[!0-9]*) # Non numeric
690 for ((egid = 101; egid <= 999; egid++)); do
691 [[ -z $(egetent group ${egid}) ]] && break
692 done
693 esac
694 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
695 ;;
696
697 *-netbsd*)
698 case ${egid} in
699 *[!0-9]*) # Non numeric
700 for ((egid = 101; egid <= 999; egid++)); do
701 [[ -z $(egetent group ${egid}) ]] && break
702 done
703 esac
704 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
705 ;;
706
707 *)
708 groupadd ${opts} ${egroup} || die "enewgroup failed"
709 ;;
710 esac
711 export SANDBOX_ON="${oldsandbox}"
712}
713
714# @FUNCTION: edos2unix 639# @FUNCTION: edos2unix
715# @USAGE: <file> [more files ...] 640# @USAGE: <file> [more files ...]
716# @DESCRIPTION: 641# @DESCRIPTION:
717# A handy replacement for dos2unix, recode, fixdos, etc... This allows you 642# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
718# to remove all of these text utilities from DEPEND variables because this 643# to remove all of these text utilities from DEPEND variables because this
719# is a script based solution. Just give it a list of files to convert and 644# is a script based solution. Just give it a list of files to convert and
720# they will all be changed from the DOS CRLF format to the UNIX LF format. 645# they will all be changed from the DOS CRLF format to the UNIX LF format.
721edos2unix() { 646edos2unix() {
722 echo "$@" | xargs sed -i 's/\r$//' 647 [[ $# -eq 0 ]] && return 0
648 sed -i 's/\r$//' -- "$@" || die
723} 649}
724 650
651# @FUNCTION: make_desktop_entry
652# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
653# @DESCRIPTION:
725# Make a desktop file ! 654# Make a .desktop file.
726# Great for making those icons in kde/gnome startmenu !
727# Amaze your friends ! Get the women ! Join today !
728# 655#
729# make_desktop_entry(<command>, [name], [icon], [type], [path]) 656# @CODE
730#
731# binary: what command does the app run with ? 657# binary: what command does the app run with ?
732# name: the name that will show up in the menu 658# name: the name that will show up in the menu
733# icon: give your little like a pretty little icon ... 659# icon: the icon to use in the menu entry
734# this can be relative (to /usr/share/pixmaps) or 660# this can be relative (to /usr/share/pixmaps) or
735# a full path to an icon 661# a full path to an icon
736# type: what kind of application is this ? for categories: 662# type: what kind of application is this?
663# for categories:
737# http://standards.freedesktop.org/menu-spec/latest/apa.html 664# http://standards.freedesktop.org/menu-spec/latest/apa.html
738# path: if your app needs to startup in a specific dir 665# if unset, function tries to guess from package's category
666# fields: extra fields to append to the desktop file; a printf string
667# @CODE
739make_desktop_entry() { 668make_desktop_entry() {
740 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 669 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
741 670
742 local exec=${1} 671 local exec=${1}
743 local name=${2:-${PN}} 672 local name=${2:-${PN}}
744 local icon=${3:-${PN}.png} 673 local icon=${3:-${PN}}
745 local type=${4} 674 local type=${4}
746 local path=${5} 675 local fields=${5}
747 676
748 if [[ -z ${type} ]] ; then 677 if [[ -z ${type} ]] ; then
749 local catmaj=${CATEGORY%%-*} 678 local catmaj=${CATEGORY%%-*}
750 local catmin=${CATEGORY##*-} 679 local catmin=${CATEGORY##*-}
751 case ${catmaj} in 680 case ${catmaj} in
752 app) 681 app)
753 case ${catmin} in 682 case ${catmin} in
754 accessibility) type=Accessibility;; 683 accessibility) type="Utility;Accessibility";;
755 admin) type=System;; 684 admin) type=System;;
756 antivirus) type=System;; 685 antivirus) type=System;;
757 arch) type=Archiving;; 686 arch) type="Utility;Archiving";;
758 backup) type=Archiving;; 687 backup) type="Utility;Archiving";;
759 cdr) type=DiscBurning;; 688 cdr) type="AudioVideo;DiscBurning";;
760 dicts) type=Dictionary;; 689 dicts) type="Office;Dictionary";;
761 doc) type=Documentation;; 690 doc) type=Documentation;;
762 editors) type=TextEditor;; 691 editors) type="Utility;TextEditor";;
763 emacs) type=TextEditor;; 692 emacs) type="Development;TextEditor";;
764 emulation) type=Emulator;; 693 emulation) type="System;Emulator";;
765 laptop) type=HardwareSettings;; 694 laptop) type="Settings;HardwareSettings";;
766 office) type=Office;; 695 office) type=Office;;
767 pda) type=PDA;; 696 pda) type="Office;PDA";;
768 vim) type=TextEditor;; 697 vim) type="Development;TextEditor";;
769 xemacs) type=TextEditor;; 698 xemacs) type="Development;TextEditor";;
770 *) type=;;
771 esac 699 esac
772 ;; 700 ;;
773 701
774 dev) 702 dev)
775 type="Development" 703 type="Development"
776 ;; 704 ;;
777 705
778 games) 706 games)
779 case ${catmin} in 707 case ${catmin} in
780 action|fps) type=ActionGame;; 708 action|fps) type=ActionGame;;
781 arcade) type=ArcadeGame;; 709 arcade) type=ArcadeGame;;
782 board) type=BoardGame;; 710 board) type=BoardGame;;
783 emulation) type=Emulator;; 711 emulation) type=Emulator;;
784 kids) type=KidsGame;; 712 kids) type=KidsGame;;
785 puzzle) type=LogicGame;; 713 puzzle) type=LogicGame;;
786 roguelike) type=RolePlaying;; 714 roguelike) type=RolePlaying;;
787 rpg) type=RolePlaying;; 715 rpg) type=RolePlaying;;
788 simulation) type=Simulation;; 716 simulation) type=Simulation;;
789 sports) type=SportsGame;; 717 sports) type=SportsGame;;
790 strategy) type=StrategyGame;; 718 strategy) type=StrategyGame;;
791 *) type=;;
792 esac 719 esac
793 type="Game;${type}" 720 type="Game;${type}"
794 ;; 721 ;;
795 722
796 gnome) 723 gnome)
805 type="Network;Email" 732 type="Network;Email"
806 ;; 733 ;;
807 734
808 media) 735 media)
809 case ${catmin} in 736 case ${catmin} in
737 gfx)
810 gfx) type=Graphics;; 738 type=Graphics
739 ;;
740 *)
741 case ${catmin} in
811 radio) type=Tuner;; 742 radio) type=Tuner;;
812 sound) type=Audio;; 743 sound) type=Audio;;
813 tv) type=TV;; 744 tv) type=TV;;
814 video) type=Video;; 745 video) type=Video;;
815 *) type=;; 746 esac
747 type="AudioVideo;${type}"
748 ;;
816 esac 749 esac
817 type="AudioVideo;${type}"
818 ;; 750 ;;
819 751
820 net) 752 net)
821 case ${catmin} in 753 case ${catmin} in
822 dialup) type=Dialup;; 754 dialup) type=Dialup;;
823 ftp) type=FileTransfer;; 755 ftp) type=FileTransfer;;
824 im) type=InstantMessaging;; 756 im) type=InstantMessaging;;
825 irc) type=IRCClient;; 757 irc) type=IRCClient;;
826 mail) type=Email;; 758 mail) type=Email;;
827 news) type=News;; 759 news) type=News;;
828 nntp) type=News;; 760 nntp) type=News;;
829 p2p) type=FileTransfer;; 761 p2p) type=FileTransfer;;
830 *) type=;; 762 voip) type=Telephony;;
831 esac 763 esac
832 type="Network;${type}" 764 type="Network;${type}"
833 ;; 765 ;;
834 766
835 sci) 767 sci)
836 case ${catmin} in 768 case ${catmin} in
837 astro*) type=Astronomy;; 769 astro*) type=Astronomy;;
838 bio*) type=Biology;; 770 bio*) type=Biology;;
839 calc*) type=Calculator;; 771 calc*) type=Calculator;;
840 chem*) type=Chemistry;; 772 chem*) type=Chemistry;;
841 elec*) type=Electronics;; 773 elec*) type=Electronics;;
842 geo*) type=Geology;; 774 geo*) type=Geology;;
843 math*) type=Math;; 775 math*) type=Math;;
844 physics) type=Physics;; 776 physics) type=Physics;;
845 visual*) type=DataVisualization;; 777 visual*) type=DataVisualization;;
846 *) type=;;
847 esac 778 esac
848 type="Science;${type}" 779 type="Education;Science;${type}"
849 ;; 780 ;;
850 781
851 sys) 782 sys)
852 type="System" 783 type="System"
853 ;; 784 ;;
854 785
855 www) 786 www)
856 case ${catmin} in 787 case ${catmin} in
857 client) type=WebBrowser;; 788 client) type=WebBrowser;;
858 *) type=;;
859 esac 789 esac
860 type="Network" 790 type="Network;${type}"
861 ;; 791 ;;
862 792
863 *) 793 *)
864 type= 794 type=
865 ;; 795 ;;
871 local desktop_name="${PN}-${SLOT}" 801 local desktop_name="${PN}-${SLOT}"
872 fi 802 fi
873 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 803 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
874 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 804 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
875 805
806 # Don't append another ";" when a valid category value is provided.
807 type=${type%;}${type:+;}
808
809 eshopts_push -s extglob
810 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
811 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
812 ewarn "allowed in .desktop files if the value is not an absolute path."
813 icon=${icon%.@(xpm|png|svg)}
814 fi
815 eshopts_pop
816
876 cat <<-EOF > "${desktop}" 817 cat <<-EOF > "${desktop}"
877 [Desktop Entry] 818 [Desktop Entry]
878 Encoding=UTF-8
879 Version=1.0
880 Name=${name} 819 Name=${name}
881 Type=Application 820 Type=Application
882 Comment=${DESCRIPTION} 821 Comment=${DESCRIPTION}
883 Exec=${exec} 822 Exec=${exec}
884 TryExec=${exec%% *} 823 TryExec=${exec%% *}
885 Path=${path}
886 Icon=${icon} 824 Icon=${icon}
887 Categories=${type}; 825 Categories=${type}
888 EOF 826 EOF
827
828 if [[ ${fields:-=} != *=* ]] ; then
829 # 5th arg used to be value to Path=
830 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
831 fields="Path=${fields}"
832 fi
833 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
889 834
890 ( 835 (
891 # wrap the env here so that the 'insinto' call 836 # wrap the env here so that the 'insinto' call
892 # doesn't corrupt the env of the caller 837 # doesn't corrupt the env of the caller
893 insinto /usr/share/applications 838 insinto /usr/share/applications
894 doins "${desktop}" 839 doins "${desktop}"
895 ) 840 ) || die "installing desktop file failed"
896} 841}
897 842
898# @FUNCTION: validate_desktop_entries 843# @FUNCTION: validate_desktop_entries
899# @USAGE: [directories] 844# @USAGE: [directories]
900# @MAINTAINER: 845# @MAINTAINER:
922 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo." 867 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
923 fi 868 fi
924} 869}
925 870
926# @FUNCTION: make_session_desktop 871# @FUNCTION: make_session_desktop
927# @USAGE: <title> <command> 872# @USAGE: <title> <command> [command args...]
928# @DESCRIPTION: 873# @DESCRIPTION:
929# Make a GDM/KDM Session file. The title is the file to execute to start the 874# Make a GDM/KDM Session file. The title is the file to execute to start the
930# Window Manager. The command is the name of the Window Manager. 875# Window Manager. The command is the name of the Window Manager.
876#
877# You can set the name of the file via the ${wm} variable.
931make_session_desktop() { 878make_session_desktop() {
932 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 879 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
933 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 880 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
934 881
935 local title=$1 882 local title=$1
936 local command=$2 883 local command=$2
937 local desktop=${T}/${wm}.desktop 884 local desktop=${T}/${wm:-${PN}}.desktop
885 shift 2
938 886
939 cat <<-EOF > "${desktop}" 887 cat <<-EOF > "${desktop}"
940 [Desktop Entry] 888 [Desktop Entry]
941 Encoding=UTF-8
942 Name=${title} 889 Name=${title}
943 Comment=This session logs you into ${title} 890 Comment=This session logs you into ${title}
944 Exec=${command} 891 Exec=${command} $*
945 TryExec=${command} 892 TryExec=${command}
946 Type=Application 893 Type=XSession
947 EOF 894 EOF
948 895
949 ( 896 (
950 # wrap the env here so that the 'insinto' call 897 # wrap the env here so that the 'insinto' call
951 # doesn't corrupt the env of the caller 898 # doesn't corrupt the env of the caller
993 insinto /usr/share/applications 940 insinto /usr/share/applications
994 newins "$@" 941 newins "$@"
995 ) 942 )
996} 943}
997 944
998# @FUNCTION: doicon 945# @FUNCTION: _iconins
999# @USAGE: <list of icons> 946# @INTERNAL
1000# @DESCRIPTION: 947# @DESCRIPTION:
1001# Install the list of icons into the icon directory (/usr/share/pixmaps). 948# function for use in doicon and newicon
1002# This is useful in conjunction with creating desktop/menu files. 949_iconins() {
1003doicon() {
1004 ( 950 (
1005 # wrap the env here so that the 'insinto' call 951 # wrap the env here so that the 'insinto' call
1006 # doesn't corrupt the env of the caller 952 # doesn't corrupt the env of the caller
1007 local i j ret 953 local funcname=$1; shift
1008 insinto /usr/share/pixmaps 954 local size dir
1009 for i in "$@" ; do 955 local context=apps
1010 if [[ -f ${i} ]] ; then 956 local theme=hicolor
1011 doins "${i}" 957
1012 ((ret+=$?)) 958 while [[ $# -gt 0 ]] ; do
1013 elif [[ -d ${i} ]] ; then 959 case $1 in
1014 for j in "${i}"/*.png ; do 960 -s|--size)
1015 doins "${j}" 961 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
1016 ((ret+=$?)) 962 size=${2%%x*}
1017 done
1018 else 963 else
1019 ((++ret)) 964 size=${2}
1020 fi 965 fi
1021 done
1022 exit ${ret}
1023 )
1024}
1025
1026# @FUNCTION: newicon
1027# @USAGE: <icon> <newname>
1028# @DESCRIPTION:
1029# Like all other new* functions, install the specified icon as newname.
1030newicon() {
1031 (
1032 # wrap the env here so that the 'insinto' call
1033 # doesn't corrupt the env of the caller
1034 insinto /usr/share/pixmaps
1035 newins "$@"
1036 )
1037}
1038
1039# for internal use only (unpack_pdv and unpack_makeself)
1040find_unpackable_file() {
1041 local src=$1
1042 if [[ -z ${src} ]] ; then
1043 src=${DISTDIR}/${A}
1044 else
1045 if [[ -e ${DISTDIR}/${src} ]] ; then
1046 src=${DISTDIR}/${src}
1047 elif [[ -e ${PWD}/${src} ]] ; then
1048 src=${PWD}/${src}
1049 elif [[ -e ${src} ]] ; then
1050 src=${src}
1051 fi
1052 fi
1053 [[ ! -e ${src} ]] && return 1
1054 echo "${src}"
1055}
1056
1057# @FUNCTION: unpack_pdv
1058# @USAGE: <file to unpack> <size of off_t>
1059# @DESCRIPTION:
1060# Unpack those pesky pdv generated files ...
1061# They're self-unpacking programs with the binary package stuffed in
1062# the middle of the archive. Valve seems to use it a lot ... too bad
1063# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1064#
1065# You have to specify the off_t size ... I have no idea how to extract that
1066# information out of the binary executable myself. Basically you pass in
1067# the size of the off_t type (in bytes) on the machine that built the pdv
1068# archive.
1069#
1070# One way to determine this is by running the following commands:
1071# strings <pdv archive> | grep lseek
1072# strace -elseek <pdv archive>
1073# Basically look for the first lseek command (we do the strings/grep because
1074# sometimes the function call is _llseek or something) and steal the 2nd
1075# parameter. Here is an example:
1076# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1077# lseek
1078# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1079# lseek(3, -4, SEEK_END) = 2981250
1080# Thus we would pass in the value of '4' as the second parameter.
1081unpack_pdv() {
1082 local src=$(find_unpackable_file "$1")
1083 local sizeoff_t=$2
1084
1085 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1086 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1087
1088 local shrtsrc=$(basename "${src}")
1089 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1090 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1091 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1092
1093 # grab metadata for debug reasons
1094 local metafile=$(emktemp)
1095 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1096
1097 # rip out the final file name from the metadata
1098 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1099 datafile=$(basename "${datafile}")
1100
1101 # now lets uncompress/untar the file if need be
1102 local tmpfile=$(emktemp)
1103 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1104
1105 local iscompressed=$(file -b "${tmpfile}")
1106 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1107 iscompressed=1
1108 mv ${tmpfile}{,.Z}
1109 gunzip ${tmpfile}
1110 else
1111 iscompressed=0
1112 fi
1113 local istar=$(file -b "${tmpfile}")
1114 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1115 istar=1
1116 else
1117 istar=0
1118 fi
1119
1120 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1121 #dd if=${src} ibs=${metaskip} count=1 \
1122 # | dd ibs=${tailskip} skip=1 \
1123 # | gzip -dc \
1124 # > ${datafile}
1125 if [ ${iscompressed} -eq 1 ] ; then
1126 if [ ${istar} -eq 1 ] ; then
1127 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1128 | head -c $((${metaskip}-${tailskip})) \
1129 | tar -xzf -
1130 else
1131 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1132 | head -c $((${metaskip}-${tailskip})) \
1133 | gzip -dc \
1134 > ${datafile}
1135 fi
1136 else
1137 if [ ${istar} -eq 1 ] ; then
1138 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1139 | head -c $((${metaskip}-${tailskip})) \
1140 | tar --no-same-owner -xf -
1141 else
1142 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1143 | head -c $((${metaskip}-${tailskip})) \
1144 > ${datafile}
1145 fi
1146 fi
1147 true
1148 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1149 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1150}
1151
1152# @FUNCTION: unpack_makeself
1153# @USAGE: [file to unpack] [offset] [tail|dd]
1154# @DESCRIPTION:
1155# Unpack those pesky makeself generated files ...
1156# They're shell scripts with the binary package tagged onto
1157# the end of the archive. Loki utilized the format as does
1158# many other game companies.
1159#
1160# If the file is not specified, then ${A} is used. If the
1161# offset is not specified then we will attempt to extract
1162# the proper offset from the script itself.
1163unpack_makeself() {
1164 local src_input=${1:-${A}}
1165 local src=$(find_unpackable_file "${src_input}")
1166 local skip=$2
1167 local exe=$3
1168
1169 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1170
1171 local shrtsrc=$(basename "${src}")
1172 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1173 if [[ -z ${skip} ]] ; then
1174 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1175 local skip=0
1176 exe=tail
1177 case ${ver} in 966 case ${size} in
1178 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 967 16|22|24|32|36|48|64|72|96|128|192|256)
1179 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 968 size=${size}x${size};;
1180 ;; 969 scalable)
1181 2.0|2.0.1)
1182 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1183 ;;
1184 2.1.1)
1185 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1186 let skip="skip + 1"
1187 ;;
1188 2.1.2)
1189 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1190 let skip="skip + 1"
1191 ;;
1192 2.1.3)
1193 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1194 let skip="skip + 1"
1195 ;;
1196 2.1.4|2.1.5)
1197 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1198 skip=$(head -n ${skip} "${src}" | wc -c)
1199 exe="dd"
1200 ;; 970 ;;
1201 *) 971 *)
1202 eerror "I'm sorry, but I was unable to support the Makeself file." 972 eerror "${size} is an unsupported icon size!"
1203 eerror "The version I detected was '${ver}'." 973 exit 1;;
1204 eerror "Please file a bug about the file ${shrtsrc} at"
1205 eerror "http://bugs.gentoo.org/ so that support can be added."
1206 die "makeself version '${ver}' not supported"
1207 ;;
1208 esac 974 esac
1209 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 975 shift 2;;
1210 fi 976 -t|--theme)
1211 case ${exe} in 977 theme=${2}
1212 tail) exe="tail -n +${skip} '${src}'";; 978 shift 2;;
1213 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 979 -c|--context)
1214 *) die "makeself cant handle exe '${exe}'" 980 context=${2}
1215 esac 981 shift 2;;
1216
1217 # lets grab the first few bytes of the file to figure out what kind of archive it is
1218 local tmpfile=$(emktemp)
1219 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1220 local filetype=$(file -b "${tmpfile}")
1221 case ${filetype} in
1222 *tar\ archive*)
1223 eval ${exe} | tar --no-same-owner -xf -
1224 ;;
1225 bzip2*)
1226 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1227 ;;
1228 gzip*)
1229 eval ${exe} | tar --no-same-owner -xzf -
1230 ;;
1231 compress*)
1232 eval ${exe} | gunzip | tar --no-same-owner -xf -
1233 ;;
1234 *) 982 *)
1235 eerror "Unknown filetype \"${filetype}\" ?"
1236 false
1237 ;;
1238 esac
1239 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1240}
1241
1242# @FUNCTION: check_license
1243# @USAGE: [license]
1244# @DESCRIPTION:
1245# Display a license for user to accept. If no license is
1246# specified, then ${LICENSE} is used.
1247check_license() {
1248 local lic=$1
1249 if [ -z "${lic}" ] ; then
1250 lic="${PORTDIR}/licenses/${LICENSE}"
1251 else
1252 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1253 lic="${PORTDIR}/licenses/${lic}"
1254 elif [ -e "${PWD}/${lic}" ] ; then
1255 lic="${PWD}/${lic}"
1256 elif [ -e "${lic}" ] ; then
1257 lic="${lic}"
1258 fi
1259 fi
1260 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1261 local l="`basename ${lic}`"
1262
1263 # here is where we check for the licenses the user already
1264 # accepted ... if we don't find a match, we make the user accept
1265 local shopts=$-
1266 local alic
1267 set -o noglob #so that bash doesn't expand "*"
1268 for alic in ${ACCEPT_LICENSE} ; do
1269 if [[ ${alic} == ${l} ]]; then
1270 set +o noglob; set -${shopts} #reset old shell opts
1271 return 0
1272 fi
1273 done
1274 set +o noglob; set -$shopts #reset old shell opts
1275
1276 local licmsg=$(emktemp)
1277 cat <<-EOF > ${licmsg}
1278 **********************************************************
1279 The following license outlines the terms of use of this
1280 package. You MUST accept this license for installation to
1281 continue. When you are done viewing, hit 'q'. If you
1282 CTRL+C out of this, the install will not run!
1283 **********************************************************
1284
1285 EOF
1286 cat ${lic} >> ${licmsg}
1287 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1288 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1289 read alic
1290 case ${alic} in
1291 yes|Yes|y|Y)
1292 return 0
1293 ;;
1294 *)
1295 echo;echo;echo
1296 eerror "You MUST accept the license to continue! Exiting!"
1297 die "Failed to accept license"
1298 ;;
1299 esac
1300}
1301
1302# @FUNCTION: cdrom_get_cds
1303# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1304# @DESCRIPTION:
1305# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1306# the whole 'non-interactive' policy, but damnit I want CD support !
1307#
1308# With these cdrom functions we handle all the user interaction and
1309# standardize everything. All you have to do is call cdrom_get_cds()
1310# and when the function returns, you can assume that the cd has been
1311# found at CDROM_ROOT.
1312#
1313# The function will attempt to locate a cd based upon a file that is on
1314# the cd. The more files you give this function, the more cds
1315# the cdrom functions will handle.
1316#
1317# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1318# etc... If you want to give the cds better names, then just export
1319# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1320# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1321# also use the CDROM_NAME_SET bash array.
1322#
1323# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1324cdrom_get_cds() {
1325 # first we figure out how many cds we're dealing with by
1326 # the # of files they gave us
1327 local cdcnt=0
1328 local f=
1329 for f in "$@" ; do
1330 ((++cdcnt))
1331 export CDROM_CHECK_${cdcnt}="$f"
1332 done
1333 export CDROM_TOTAL_CDS=${cdcnt}
1334 export CDROM_CURRENT_CD=1
1335
1336 # now we see if the user gave use CD_ROOT ...
1337 # if they did, let's just believe them that it's correct
1338 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1339 local var=
1340 cdcnt=0
1341 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1342 ((++cdcnt))
1343 var="CD_ROOT_${cdcnt}"
1344 [[ -z ${!var} ]] && var="CD_ROOT"
1345 if [[ -z ${!var} ]] ; then 983 if [[ -z ${size} ]] ; then
1346 eerror "You must either use just the CD_ROOT" 984 insinto /usr/share/pixmaps
1347 eerror "or specify ALL the CD_ROOT_X variables." 985 else
1348 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables." 986 insinto /usr/share/icons/${theme}/${size}/${context}
1349 die "could not locate CD_ROOT_${cdcnt}"
1350 fi 987 fi
1351 done
1352 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1353 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1354 export CDROM_SET=-1
1355 for f in ${CDROM_CHECK_1//:/ } ; do
1356 ((++CDROM_SET))
1357 [[ -e ${CD_ROOT}/${f} ]] && break
1358 done
1359 export CDROM_MATCH=${f}
1360 return
1361 fi
1362 988
1363 # User didn't help us out so lets make sure they know they can 989 if [[ ${funcname} == doicon ]] ; then
1364 # simplify the whole process ...
1365 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1366 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1367 echo
1368 einfo "If you do not have the CD, but have the data files"
1369 einfo "mounted somewhere on your filesystem, just export"
1370 einfo "the variable CD_ROOT so that it points to the"
1371 einfo "directory containing the files."
1372 echo
1373 einfo "For example:"
1374 einfo "export CD_ROOT=/mnt/cdrom"
1375 echo
1376 else
1377 if [[ -n ${CDROM_NAME_SET} ]] ; then
1378 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1379 cdcnt=0
1380 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1381 ((++cdcnt))
1382 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1383 done
1384 fi
1385
1386 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1387 cdcnt=0
1388 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1389 ((++cdcnt))
1390 var="CDROM_NAME_${cdcnt}"
1391 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1392 done
1393 echo
1394 einfo "If you do not have the CDs, but have the data files"
1395 einfo "mounted somewhere on your filesystem, just export"
1396 einfo "the following variables so they point to the right place:"
1397 einfon ""
1398 cdcnt=0
1399 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1400 ((++cdcnt))
1401 echo -n " CD_ROOT_${cdcnt}"
1402 done
1403 echo
1404 einfo "Or, if you have all the files in the same place, or"
1405 einfo "you only have one cdrom, you can export CD_ROOT"
1406 einfo "and that place will be used as the same data source"
1407 einfo "for all the CDs."
1408 echo
1409 einfo "For example:"
1410 einfo "export CD_ROOT_1=/mnt/cdrom"
1411 echo
1412 fi
1413
1414 export CDROM_SET=""
1415 export CDROM_CURRENT_CD=0
1416 cdrom_load_next_cd
1417}
1418
1419# @FUNCTION: cdrom_load_next_cd
1420# @DESCRIPTION:
1421# Some packages are so big they come on multiple CDs. When you're done reading
1422# files off a CD and want access to the next one, just call this function.
1423# Again, all the messy details of user interaction are taken care of for you.
1424# Once this returns, just read the variable CDROM_ROOT for the location of the
1425# mounted CD. Note that you can only go forward in the CD list, so make sure
1426# you only call this function when you're done using the current CD.
1427cdrom_load_next_cd() {
1428 local var
1429 ((++CDROM_CURRENT_CD))
1430
1431 unset CDROM_ROOT
1432 var=CD_ROOT_${CDROM_CURRENT_CD}
1433 [[ -z ${!var} ]] && var="CD_ROOT"
1434 if [[ -z ${!var} ]] ; then 990 if [[ -f $1 ]] ; then
1435 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 991 doins "${1}"
1436 _cdrom_locate_file_on_cd ${!var} 992 elif [[ -d $1 ]] ; then
1437 else 993 shopt -s nullglob
1438 export CDROM_ROOT=${!var} 994 doins "${1}"/*.{png,svg}
1439 fi 995 shopt -u nullglob
1440
1441 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1442}
1443
1444# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1445# functions. this should *never* be called from an ebuild.
1446# all it does is try to locate a give file on a cd ... if the cd isn't
1447# found, then a message asking for the user to insert the cdrom will be
1448# displayed and we'll hang out here until:
1449# (1) the file is found on a mounted cdrom
1450# (2) the user hits CTRL+C
1451_cdrom_locate_file_on_cd() {
1452 local mline=""
1453 local showedmsg=0
1454
1455 while [[ -z ${CDROM_ROOT} ]] ; do
1456 local i=0
1457 local -a cdset=(${*//:/ })
1458 if [[ -n ${CDROM_SET} ]] ; then
1459 cdset=(${cdset[${CDROM_SET}]})
1460 fi
1461
1462 while [[ -n ${cdset[${i}]} ]] ; do
1463 local dir=$(dirname ${cdset[${i}]})
1464 local file=$(basename ${cdset[${i}]})
1465
1466 local point= node= fs= foo=
1467 while read point node fs foo ; do
1468 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1469 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1470 && continue
1471 point=${point//\040/ }
1472 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1473 export CDROM_ROOT=${point}
1474 export CDROM_SET=${i}
1475 export CDROM_MATCH=${cdset[${i}]}
1476 return
1477 done <<< "$(get_mounts)"
1478
1479 ((++i))
1480 done
1481
1482 echo
1483 if [[ ${showedmsg} -eq 0 ]] ; then
1484 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1485 if [[ -z ${CDROM_NAME} ]] ; then
1486 einfo "Please insert+mount the cdrom for ${PN} now !"
1487 else 996 else
1488 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !" 997 eerror "${1} is not a valid file/directory!"
998 exit 1
1489 fi 999 fi
1490 else 1000 else
1491 if [[ -z ${CDROM_NAME_1} ]] ; then 1001 break
1492 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1493 else
1494 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1495 einfo "Please insert+mount the ${!var} cdrom now !"
1496 fi
1497 fi 1002 fi
1498 showedmsg=1 1003 shift 1;;
1499 fi 1004 esac
1500 einfo "Press return to scan for the cd again"
1501 einfo "or hit CTRL+C to abort the emerge."
1502 echo
1503 einfo "If you are having trouble with the detection"
1504 einfo "of your CD, it is possible that you do not have"
1505 einfo "Joliet support enabled in your kernel. Please"
1506 einfo "check that CONFIG_JOLIET is enabled in your kernel."
1507 read || die "something is screwed with your system"
1508 done 1005 done
1006 if [[ ${funcname} == newicon ]] ; then
1007 newins "$@"
1008 fi
1009 ) || die
1509} 1010}
1510 1011
1012# @FUNCTION: doicon
1013# @USAGE: [options] <icons>
1014# @DESCRIPTION:
1015# Install icon into the icon directory /usr/share/icons or into
1016# /usr/share/pixmaps if "--size" is not set.
1017# This is useful in conjunction with creating desktop/menu files.
1018#
1019# @CODE
1020# options:
1021# -s, --size
1022# !!! must specify to install into /usr/share/icons/... !!!
1023# size of the icon, like 48 or 48x48
1024# supported icon sizes are:
1025# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1026# -c, --context
1027# defaults to "apps"
1028# -t, --theme
1029# defaults to "hicolor"
1030#
1031# icons: list of icons
1032#
1033# example 1: doicon foobar.png fuqbar.svg suckbar.png
1034# results in: insinto /usr/share/pixmaps
1035# doins foobar.png fuqbar.svg suckbar.png
1036#
1037# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
1038# results in: insinto /usr/share/icons/hicolor/48x48/apps
1039# doins foobar.png fuqbar.png blobbar.png
1040# @CODE
1041doicon() {
1042 _iconins ${FUNCNAME} "$@"
1043}
1044
1045# @FUNCTION: newicon
1046# @USAGE: [options] <icon> <newname>
1047# @DESCRIPTION:
1048# Like doicon, install the specified icon as newname.
1049#
1050# @CODE
1051# example 1: newicon foobar.png NEWNAME.png
1052# results in: insinto /usr/share/pixmaps
1053# newins foobar.png NEWNAME.png
1054#
1055# example 2: newicon -s 48 foobar.png NEWNAME.png
1056# results in: insinto /usr/share/icons/hicolor/48x48/apps
1057# newins foobar.png NEWNAME.png
1058# @CODE
1059newicon() {
1060 _iconins ${FUNCNAME} "$@"
1061}
1062
1063# @FUNCTION: strip-linguas
1064# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1065# @DESCRIPTION:
1511# Make sure that LINGUAS only contains languages that 1066# Make sure that LINGUAS only contains languages that
1512# a package can support 1067# a package can support. The first form allows you to
1513# 1068# specify a list of LINGUAS. The -i builds a list of po
1514# usage: strip-linguas <allow LINGUAS> 1069# files found in all the directories and uses the
1515# strip-linguas -i <directories of .po files> 1070# intersection of the lists. The -u builds a list of po
1516# strip-linguas -u <directories of .po files> 1071# files found in all the directories and uses the union
1517# 1072# of the lists.
1518# The first form allows you to specify a list of LINGUAS.
1519# The -i builds a list of po files found in all the
1520# directories and uses the intersection of the lists.
1521# The -u builds a list of po files found in all the
1522# directories and uses the union of the lists.
1523strip-linguas() { 1073strip-linguas() {
1524 local ls newls nols 1074 local ls newls nols
1525 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1075 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1526 local op=$1; shift 1076 local op=$1; shift
1527 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1077 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1528 local d f 1078 local d f
1529 for d in "$@" ; do 1079 for d in "$@" ; do
1530 if [[ ${op} == "-u" ]] ; then 1080 if [[ ${op} == "-u" ]] ; then
1531 newls=${ls} 1081 newls=${ls}
1532 else 1082 else
1533 newls="" 1083 newls=""
1534 fi 1084 fi
1535 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1085 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1536 if [[ ${op} == "-i" ]] ; then 1086 if [[ ${op} == "-i" ]] ; then
1537 hasq ${f} ${ls} && newls="${newls} ${f}" 1087 has ${f} ${ls} && newls="${newls} ${f}"
1538 else 1088 else
1539 hasq ${f} ${ls} || newls="${newls} ${f}" 1089 has ${f} ${ls} || newls="${newls} ${f}"
1540 fi 1090 fi
1541 done 1091 done
1542 ls=${newls} 1092 ls=${newls}
1543 done 1093 done
1544 else 1094 else
1546 fi 1096 fi
1547 1097
1548 nols="" 1098 nols=""
1549 newls="" 1099 newls=""
1550 for f in ${LINGUAS} ; do 1100 for f in ${LINGUAS} ; do
1551 if hasq ${f} ${ls} ; then 1101 if has ${f} ${ls} ; then
1552 newls="${newls} ${f}" 1102 newls="${newls} ${f}"
1553 else 1103 else
1554 nols="${nols} ${f}" 1104 nols="${nols} ${f}"
1555 fi 1105 fi
1556 done 1106 done
1557 [[ -n ${nols} ]] \ 1107 [[ -n ${nols} ]] \
1558 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1108 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1559 export LINGUAS=${newls:1} 1109 export LINGUAS=${newls:1}
1560}
1561
1562# @FUNCTION: set_arch_to_kernel
1563# @DESCRIPTION:
1564# Set the env ARCH to match what the kernel expects.
1565set_arch_to_kernel() {
1566 i=10
1567 while ((i--)) ; do
1568 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1569 done
1570 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1571 case ${ARCH} in
1572 x86) export ARCH="i386";;
1573 amd64) export ARCH="x86_64";;
1574 hppa) export ARCH="parisc";;
1575 mips) export ARCH="mips";;
1576 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1577 *) export ARCH="${ARCH}";;
1578 esac
1579}
1580
1581# @FUNCTION: set_arch_to_portage
1582# @DESCRIPTION:
1583# Set the env ARCH to match what portage expects.
1584set_arch_to_portage() {
1585 i=10
1586 while ((i--)) ; do
1587 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1588 done
1589 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1590} 1110}
1591 1111
1592# @FUNCTION: preserve_old_lib 1112# @FUNCTION: preserve_old_lib
1593# @USAGE: <libs to preserve> [more libs] 1113# @USAGE: <libs to preserve> [more libs]
1594# @DESCRIPTION: 1114# @DESCRIPTION:
1603 eerror "preserve_old_lib() must be called from pkg_preinst() only" 1123 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1604 die "Invalid preserve_old_lib() usage" 1124 die "Invalid preserve_old_lib() usage"
1605 fi 1125 fi
1606 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]" 1126 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1607 1127
1128 # let portage worry about it
1129 has preserve-libs ${FEATURES} && return 0
1130
1608 local lib dir 1131 local lib dir
1609 for lib in "$@" ; do 1132 for lib in "$@" ; do
1610 [[ -e ${ROOT}/${lib} ]] || continue 1133 [[ -e ${ROOT}/${lib} ]] || continue
1611 dir=${lib%/*} 1134 dir=${lib%/*}
1612 dodir ${dir} || die "dodir ${dir} failed" 1135 dodir ${dir} || die "dodir ${dir} failed"
1622preserve_old_lib_notify() { 1145preserve_old_lib_notify() {
1623 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then 1146 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1624 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only" 1147 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1625 die "Invalid preserve_old_lib_notify() usage" 1148 die "Invalid preserve_old_lib_notify() usage"
1626 fi 1149 fi
1150
1151 # let portage worry about it
1152 has preserve-libs ${FEATURES} && return 0
1627 1153
1628 local lib notice=0 1154 local lib notice=0
1629 for lib in "$@" ; do 1155 for lib in "$@" ; do
1630 [[ -e ${ROOT}/${lib} ]] || continue 1156 [[ -e ${ROOT}/${lib} ]] || continue
1631 if [[ ${notice} -eq 0 ]] ; then 1157 if [[ ${notice} -eq 0 ]] ; then
1635 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1161 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1636 ewarn "in order to remove these old dependencies. If you do not have this" 1162 ewarn "in order to remove these old dependencies. If you do not have this"
1637 ewarn "helper program, simply emerge the 'gentoolkit' package." 1163 ewarn "helper program, simply emerge the 'gentoolkit' package."
1638 ewarn 1164 ewarn
1639 fi 1165 fi
1640 ewarn " # revdep-rebuild --library ${lib##*/}" 1166 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1641 done 1167 done
1642} 1168}
1643 1169
1644# @FUNCTION: built_with_use 1170# @FUNCTION: built_with_use
1645# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1171# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1646# @DESCRIPTION: 1172# @DESCRIPTION:
1173#
1174# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1175#
1647# A temporary hack until portage properly supports DEPENDing on USE 1176# A temporary hack until portage properly supports DEPENDing on USE
1648# flags being enabled in packages. This will check to see if the specified 1177# flags being enabled in packages. This will check to see if the specified
1649# DEPEND atom was built with the specified list of USE flags. The 1178# DEPEND atom was built with the specified list of USE flags. The
1650# --missing option controls the behavior if called on a package that does 1179# --missing option controls the behavior if called on a package that does
1651# not actually support the defined USE flags (aka listed in IUSE). 1180# not actually support the defined USE flags (aka listed in IUSE).
1652# The default is to abort (call die). The -a and -o flags control 1181# The default is to abort (call die). The -a and -o flags control
1653# the requirements of the USE flags. They correspond to "and" and "or" 1182# the requirements of the USE flags. They correspond to "and" and "or"
1654# logic. So the -a flag means all listed USE flags must be enabled 1183# logic. So the -a flag means all listed USE flags must be enabled
1655# while the -o flag means at least one of the listed fIUSE flags must be 1184# while the -o flag means at least one of the listed IUSE flags must be
1656# enabled. The --hidden option is really for internal use only as it 1185# enabled. The --hidden option is really for internal use only as it
1657# means the USE flag we're checking is hidden expanded, so it won't be found 1186# means the USE flag we're checking is hidden expanded, so it won't be found
1658# in IUSE like normal USE flags. 1187# in IUSE like normal USE flags.
1659# 1188#
1660# Remember that this function isn't terribly intelligent so order of optional 1189# Remember that this function isn't terribly intelligent so order of optional
1661# flags matter. 1190# flags matter.
1662built_with_use() { 1191built_with_use() {
1663 local hidden="no" 1192 local hidden="no"
1664 if [[ $1 == "--hidden" ]] ; then 1193 if [[ $1 == "--hidden" ]] ; then
1695 die) die "Unable to determine what USE flags $PKG was built with";; 1224 die) die "Unable to determine what USE flags $PKG was built with";;
1696 esac 1225 esac
1697 fi 1226 fi
1698 1227
1699 if [[ ${hidden} == "no" ]] ; then 1228 if [[ ${hidden} == "no" ]] ; then
1700 local IUSE_BUILT=$(<${IUSEFILE}) 1229 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1701 # Don't check USE_EXPAND #147237 1230 # Don't check USE_EXPAND #147237
1702 local expand 1231 local expand
1703 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do 1232 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1704 if [[ $1 == ${expand}_* ]] ; then 1233 if [[ $1 == ${expand}_* ]] ; then
1705 expand="" 1234 expand=""
1706 break 1235 break
1707 fi 1236 fi
1708 done 1237 done
1709 if [[ -n ${expand} ]] ; then 1238 if [[ -n ${expand} ]] ; then
1710 if ! has $1 ${IUSE_BUILT} ; then 1239 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1711 case ${missing_action} in 1240 case ${missing_action} in
1712 true) return 0;; 1241 true) return 0;;
1713 false) return 1;; 1242 false) return 1;;
1714 die) die "$PKG does not actually support the $1 USE flag!";; 1243 die) die "$PKG does not actually support the $1 USE flag!";;
1715 esac 1244 esac
1727 shift 1256 shift
1728 done 1257 done
1729 [[ ${opt} = "-a" ]] 1258 [[ ${opt} = "-a" ]]
1730} 1259}
1731 1260
1732# @DESCRIPTION: epunt_cxx 1261# @FUNCTION: epunt_cxx
1733# @USAGE: [dir to scan] 1262# @USAGE: [dir to scan]
1734# @DESCRIPTION: 1263# @DESCRIPTION:
1735# Many configure scripts wrongly bail when a C++ compiler could not be 1264# Many configure scripts wrongly bail when a C++ compiler could not be
1736# detected. If dir is not specified, then it defaults to ${S}. 1265# detected. If dir is not specified, then it defaults to ${S}.
1737# 1266#
1739epunt_cxx() { 1268epunt_cxx() {
1740 local dir=$1 1269 local dir=$1
1741 [[ -z ${dir} ]] && dir=${S} 1270 [[ -z ${dir} ]] && dir=${S}
1742 ebegin "Removing useless C++ checks" 1271 ebegin "Removing useless C++ checks"
1743 local f 1272 local f
1744 for f in $(find ${dir} -name configure) ; do 1273 find "${dir}" -name configure | while read f ; do
1745 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1274 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1746 done 1275 done
1747 eend 0 1276 eend 0
1748} 1277}
1749 1278
1750# @FUNCTION: make_wrapper 1279# @FUNCTION: make_wrapper
1751# @USAGE: <wrapper> <target> <chdir> [libpaths] [installpath] 1280# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1752# @DESCRIPTION: 1281# @DESCRIPTION:
1753# Create a shell wrapper script named wrapper in installpath 1282# Create a shell wrapper script named wrapper in installpath
1754# (defaults to the bindir) to execute target (default of wrapper) by 1283# (defaults to the bindir) to execute target (default of wrapper) by
1755# first optionally setting LD_LIBRARY_PATH to the colon-delimited 1284# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1756# libpaths followed by optionally changing directory to chdir. 1285# libpaths followed by optionally changing directory to chdir.
1779 ) || die 1308 ) || die
1780 else 1309 else
1781 newbin "${tmpwrapper}" "${wrapper}" || die 1310 newbin "${tmpwrapper}" "${wrapper}" || die
1782 fi 1311 fi
1783} 1312}
1313
1314# @FUNCTION: path_exists
1315# @USAGE: [-a|-o] <paths>
1316# @DESCRIPTION:
1317# Check if the specified paths exist. Works for all types of paths
1318# (files/dirs/etc...). The -a and -o flags control the requirements
1319# of the paths. They correspond to "and" and "or" logic. So the -a
1320# flag means all the paths must exist while the -o flag means at least
1321# one of the paths must exist. The default behavior is "and". If no
1322# paths are specified, then the return value is "false".
1323path_exists() {
1324 local opt=$1
1325 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1326
1327 # no paths -> return false
1328 # same behavior as: [[ -e "" ]]
1329 [[ $# -eq 0 ]] && return 1
1330
1331 local p r=0
1332 for p in "$@" ; do
1333 [[ -e ${p} ]]
1334 : $(( r += $? ))
1335 done
1336
1337 case ${opt} in
1338 -a) return $(( r != 0 )) ;;
1339 -o) return $(( r == $# )) ;;
1340 esac
1341}
1342
1343# @FUNCTION: in_iuse
1344# @USAGE: <flag>
1345# @DESCRIPTION:
1346# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1347# as necessary.
1348#
1349# Note that this function should not be used in the global scope.
1350in_iuse() {
1351 debug-print-function ${FUNCNAME} "${@}"
1352 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1353
1354 local flag=${1}
1355 local liuse=( ${IUSE} )
1356
1357 has "${flag}" "${liuse[@]#[+-]}"
1358}
1359
1360# @FUNCTION: use_if_iuse
1361# @USAGE: <flag>
1362# @DESCRIPTION:
1363# Return true if the given flag is in USE and IUSE.
1364#
1365# Note that this function should not be used in the global scope.
1366use_if_iuse() {
1367 in_iuse $1 || return 1
1368 use $1
1369}
1370
1371# @FUNCTION: usex
1372# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1373# @DESCRIPTION:
1374# Proxy to declare usex for package managers or EAPIs that do not provide it
1375# and use the package manager implementation when available (i.e. EAPI >= 5).
1376# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1377# otherwise echo [false output][false suffix] (defaults to "no").
1378if has "${EAPI:-0}" 0 1 2 3 4; then
1379 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1380fi
1381
1382# @FUNCTION: prune_libtool_files
1383# @USAGE: [--all]
1384# @DESCRIPTION:
1385# Locate unnecessary libtool files (.la) and libtool static archives
1386# (.a) and remove them from installation image.
1387#
1388# By default, .la files are removed whenever the static linkage can
1389# either be performed using pkg-config or doesn't introduce additional
1390# flags.
1391#
1392# If '--all' argument is passed, all .la files are removed. This is
1393# usually useful when the package installs plugins and does not use .la
1394# files for loading them.
1395#
1396# The .a files are only removed whenever corresponding .la files state
1397# that they should not be linked to, i.e. whenever these files
1398# correspond to plugins.
1399#
1400# Note: if your package installs both static libraries and .pc files,
1401# you need to add pkg-config to your DEPEND.
1402prune_libtool_files() {
1403 debug-print-function ${FUNCNAME} "$@"
1404
1405 local removing_all opt
1406 for opt; do
1407 case "${opt}" in
1408 --all)
1409 removing_all=1
1410 ;;
1411 *)
1412 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1413 esac
1414 done
1415
1416 local f
1417 local queue=()
1418 while IFS= read -r -d '' f; do # for all .la files
1419 local archivefile=${f/%.la/.a}
1420
1421 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1422
1423 # Remove static libs we're not supposed to link against.
1424 if grep -q '^shouldnotlink=yes$' "${f}"; then
1425 if [[ -f ${archivefile} ]]; then
1426 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1427 queue+=( "${archivefile}" )
1428 fi
1429
1430 # The .la file may be used by a module loader, so avoid removing it
1431 # unless explicitly requested.
1432 [[ ${removing_all} ]] || continue
1433 fi
1434
1435 # Remove .la files when:
1436 # - user explicitly wants us to remove all .la files,
1437 # - respective static archive doesn't exist,
1438 # - they are covered by a .pc file already,
1439 # - they don't provide any new information (no libs & no flags).
1440 local reason pkgconfig_scanned
1441 if [[ ${removing_all} ]]; then
1442 reason='requested'
1443 elif [[ ! -f ${archivefile} ]]; then
1444 reason='no static archive'
1445 elif [[ ! $(sed -nre \
1446 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1447 "${f}") ]]; then
1448 reason='no libs & flags'
1449 else
1450 if [[ ! ${pkgconfig_scanned} ]]; then
1451 # Create a list of all .pc-covered libs.
1452 local pc_libs=()
1453 if [[ ! ${removing_all} ]]; then
1454 local f
1455 local tf=${T}/prune-lt-files.pc
1456 local pkgconf=$(tc-getPKG_CONFIG)
1457
1458 while IFS= read -r -d '' f; do # for all .pc files
1459 local arg
1460
1461 sed -e '/^Requires:/d' "${f}" > "${tf}"
1462 for arg in $("${pkgconf}" --libs "${tf}"); do
1463 [[ ${arg} == -l* ]] && pc_libs+=( lib${arg#-l}.la )
1464 done
1465 done < <(find "${D}" -type f -name '*.pc' -print0)
1466
1467 rm -f "${tf}"
1468 fi
1469
1470 pkgconfig_scanned=1
1471 fi
1472
1473 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1474 fi
1475
1476 if [[ ${reason} ]]; then
1477 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1478 queue+=( "${f}" )
1479 fi
1480 done < <(find "${D}" -xtype f -name '*.la' -print0)
1481
1482 if [[ ${queue[@]} ]]; then
1483 rm -f "${queue[@]}"
1484 fi
1485}
1486
1487check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1488
1489fi

Legend:
Removed from v.1.285  
changed lines
  Added in v.1.407

  ViewVC Help
Powered by ViewVC 1.1.20